export declare type EventHandler = (event?: any) => void;
export interface Emitter {
    on(type: string, handler: EventHandler): void;
    off(type: string, handler: EventHandler): void;
    emit(type: string, evt: any): void;
}
/** Mitt: Tiny (~200b) functional event emitter / pubsub.
 *  @name mitt
 *  @returns {Emitter}
 */
export default function mitt(): Emitter;
