import { apc, modelName, modelSymbol, parentSymbol, vpc } from './symbols';
import { EventHandler } from './emitter';
export declare type Event = {
    path?: string;
    value?: string;
    [index: string]: any;
};
export declare type EmitFn = (evt: string, val: Event) => void;
export interface ModelCommons<S> {
    onAction: (fn: EventHandler, after?: boolean) => Function;
    onSnapshot: (fn: EventHandler) => Function;
    onPatch: (fn: EventHandler) => Function;
    getSnapshot: () => object;
    applySnapshot: (snapshot: object, dontemit?: boolean) => void;
    getParent: () => Model<any> | null;
    getRoot: () => Model<any>;
    [modelName]: string;
    [modelSymbol]: boolean;
    [parentSymbol]: (emit: EmitFn, _parent: Model<S>, _path: string) => void;
}
export declare type Model<S> = ModelCommons<S> & {
    [vpc]: Model<S>;
    [apc]: Model<S>;
    [index: string]: any;
} & S;
export declare type Init<S> = {
    [index: string]: ((this: Model<S>, ...args: any[]) => any) | string | number | object;
};
export declare type InitFn<K, S extends Init<K>> = (obj?: any) => S;
export declare type Obj = {
    [index: string]: any;
};
export default function model<S extends Init<any>>(name: string, init: InitFn<S, S>): (obj?: Obj) => Model<S>;
export declare function clearCache(): void;
